import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:jwtson/jwtson_method_channel.dart';
import 'jwtson_platform_interface.dart';

/*
 * Dayona
 * Created on Thu Jun 02 2022
 * email : dayonaart@gmail.com
 * Copyright (c) 2022
 */

class Jwtson {
  /// Generate And Sign JWT TOKEN
  /// - sign key and data must not be null
  Future<String?> generateToken(
      {@required String? key, @required Map<String, dynamic>? data}) async {
    assert(key != null && data != null);
    return JwtsonPlatform.instance.generateToken(key, jsonEncode(data));
  }

  /// Veriify JWT TOKEN
  /// - sign key and data ( JWT token ) must not be null
  Future<bool?> verifyJwtToken({@required String? key, @required String? data}) async {
    assert(key != null && data != null);
    return JwtsonPlatform.instance.verifyJwtToken(key, data);
  }

  /// Decode And with sign key JWT TOKEN
  /// - sign key and data ( JWT token ) must not be null
  Future<PayloadResult?> decodeJwtToken({@required String? key, @required String? data}) async {
    assert(key != null && data != null);
    return JwtsonPlatform.instance.decodeJwtToken(key, data);
  }
}
